package com.terraformersmc.traverse;

import com.terraformersmc.terraform.config.BiomeConfigHandler;
import com.terraformersmc.traverse.biome.TraverseBiomes;
import com.terraformersmc.traverse.block.TraverseBlocks;
import com.terraformersmc.traverse.entity.TraverseEntities;
import com.terraformersmc.traverse.feature.TraverseFeatures;
import com.terraformersmc.traverse.generation.TraverseGeneration;
import com.terraformersmc.traverse.surfacebuilder.TraverseSurfaceBuilders;
import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.client.itemgroup.FabricItemGroupBuilder;
import net.minecraft.class_1799;
import net.minecraft.class_2371;
import net.minecraft.class_2378;
import net.minecraft.class_2960;

public class Traverse implements ModInitializer {

	public static final String MOD_ID = "traverse";
	public static final BiomeConfigHandler BIOME_CONFIG_HANDLER = new BiomeConfigHandler(MOD_ID);

	@Override
	public void onInitialize() {
		register();
	}

	public static void register() {
		TraverseBlocks.register();
		TraverseEntities.register();
		TraverseSurfaceBuilders.register();
		TraverseFeatures.register();
		TraverseBiomes.register();
		TraverseGeneration.register();

		FabricItemGroupBuilder.create(new class_2960(MOD_ID, "items")).icon(() -> TraverseBlocks.FIR_SAPLING.method_8389().method_7854()).appendItems(stacks -> class_2378.field_11142.forEach(item -> {
			if (class_2378.field_11142.method_10221(item).method_12836().equals(MOD_ID)) {
				item.method_7850(item.method_7859(), (class_2371<class_1799>) stacks);
			}
		})).build();
	}

}
