package com.terraformersmc.traverse.feature;

import com.google.common.collect.ImmutableList;
import com.terraformersmc.terraform.feature.FallenLogFeatureConfig;
import com.terraformersmc.traverse.block.TraverseBlocks;
import net.minecraft.class_1959;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2893;
import net.minecraft.class_2951;
import net.minecraft.class_2997;
import net.minecraft.class_3031;
import net.minecraft.class_3124;
import net.minecraft.class_3141;
import net.minecraft.class_3271;
import net.minecraft.class_3273;
import net.minecraft.class_3276;
import net.minecraft.class_3284;
import net.minecraft.class_3864;
import net.minecraft.class_4633;
import net.minecraft.class_4638;
import net.minecraft.class_4640;
import net.minecraft.class_4643;
import net.minecraft.class_4646;
import net.minecraft.class_4650;
import net.minecraft.class_4656;
import net.minecraft.class_4657;
import net.minecraft.class_4661;
import net.minecraft.world.gen.decorator.*;
import net.minecraft.world.gen.feature.*;

public class TraverseBiomeFeatures {
	public static final class_4640 RED_AUTUMNAL_TREE_CONFIG;
	public static final class_4640 ORANGE_AUTUMNAL_TREE_CONFIG;
	public static final class_4640 YELLOW_AUTUMNAL_TREE_CONFIG;
	public static final class_4640 BROWN_AUTUMNAL_TREE_CONFIG;
	public static final class_4640 FIR_TREE_CONFIG;
	private static final class_4640 TALL_SWAMP_TREE_CONFIG;
	private static final class_4638 LUSH_FLOWER_CONFIG;

	private static class_4640 oakLike(class_2248 trunk, class_2248 leaves) {
		return new class_4640.class_4641(
				new class_4656(trunk.method_9564()),
				new class_4656(leaves.method_9564()),
				new class_4646(2, 0)
		).method_23428(4).method_23430(2).method_23437(3).method_23427().method_23431();
	}

	static {
		RED_AUTUMNAL_TREE_CONFIG = oakLike(class_2246.field_10010, TraverseBlocks.RED_AUTUMNAL_LEAVES);
		ORANGE_AUTUMNAL_TREE_CONFIG = oakLike(class_2246.field_10431, TraverseBlocks.ORANGE_AUTUMNAL_LEAVES);
		YELLOW_AUTUMNAL_TREE_CONFIG = oakLike(class_2246.field_10511, TraverseBlocks.YELLOW_AUTUMNAL_LEAVES);
		BROWN_AUTUMNAL_TREE_CONFIG = oakLike(class_2246.field_10431, TraverseBlocks.BROWN_AUTUMNAL_LEAVES);
		FIR_TREE_CONFIG = new class_4640.class_4641(
				new class_4656(TraverseBlocks.FIR_LOG.method_9564()),
				new class_4656(TraverseBlocks.FIR_LEAVES.method_9564()),
				new class_4650(2, 1)
		).method_23428(15).method_23430(15).method_23433(1).method_23434(4).method_23436(2).method_23427().method_23431();

		TALL_SWAMP_TREE_CONFIG = new class_4640.class_4641 (
				new class_4656(class_2246.field_10431.method_9564()),
				new class_4656(class_2246.field_10503.method_9564()),
				new class_4646(3, 0)
		).method_23428(7).method_23430(3).method_23437(3).method_23439(1).method_23429(ImmutableList.of(new class_4661())).method_23431();

		class_4657 provider = new class_4657();

		provider.method_23458(class_2246.field_10449.method_9564(), 12);
		provider.method_23458(class_2246.field_10573.method_9564(), 12);
		provider.method_23458(class_2246.field_10554.method_9564(), 12);
		provider.method_23458(class_2246.field_10182.method_9564(), 8);
		provider.method_23458(class_2246.field_10048.method_9564(), 1);
		provider.method_23458(class_2246.field_10315.method_9564(), 1);
		provider.method_23458(class_2246.field_10270.method_9564(), 1);
		provider.method_23458(class_2246.field_10156.method_9564(), 1);

		class_4638.class_4639 lushGrassBuilder = new class_4638.class_4639(provider, new class_4633());
		LUSH_FLOWER_CONFIG = lushGrassBuilder.method_23417(64).method_23419().method_23424();
	}

	public static void addShrubs(class_1959 biome, int count) {
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_13537.method_23397(new class_4643.class_4644(
			new class_4656(class_2246.field_10431.method_9564()), new class_4656(class_2246.field_10503.method_9564())).method_23445())
			.method_23388(class_3284.field_14267.method_23475(new class_3276(0, 0.5F, count))));
	}

	public static void addAutumnalWoodsTrees(class_1959 biome) {
		biome.method_8719(
			class_2893.class_2895.field_13178,
			class_3031.field_13593.method_23397(new class_3141(
				ImmutableList.of(
					class_3031.field_13510.method_23397(RED_AUTUMNAL_TREE_CONFIG).method_23387(0.25F),
					class_3031.field_13510.method_23397(ORANGE_AUTUMNAL_TREE_CONFIG).method_23387(0.25F),
					class_3031.field_13510.method_23397(YELLOW_AUTUMNAL_TREE_CONFIG).method_23387(0.25F),
					class_3031.field_13510.method_23397(BROWN_AUTUMNAL_TREE_CONFIG).method_23387(0.25F)
				),
				class_3031.field_13510.method_23397(class_3864.field_21126)))
				.method_23388(class_3284.field_14267.method_23475(new class_3276(10, 0.1F, 1))));
	}

	public static void addCliffsMineables(class_1959 biome) {
		biome.method_8719(class_2893.class_2895.field_13176, class_3031.field_13517.method_23397(new class_3124(class_3124.class_3125.field_13730, class_2246.field_10566.method_9564(), 33)).method_23388(class_3284.field_14241.method_23475(new class_2997(10, 0, 0, 70))));
		biome.method_8719(class_2893.class_2895.field_13176, class_3031.field_13517.method_23397(new class_3124(class_3124.class_3125.field_13730, class_2246.field_10255.method_9564(), 33)).method_23388(class_3284.field_14241.method_23475(new class_2997(8, 0, 0, 70))));
		biome.method_8719(class_2893.class_2895.field_13176, class_3031.field_13517.method_23397(new class_3124(class_3124.class_3125.field_13730, class_2246.field_10474.method_9564(), 33)).method_23388(class_3284.field_14241.method_23475(new class_2997(10, 0, 0, 70))));
		biome.method_8719(class_2893.class_2895.field_13176, class_3031.field_13517.method_23397(new class_3124(class_3124.class_3125.field_13730, class_2246.field_10508.method_9564(), 33)).method_23388(class_3284.field_14241.method_23475(new class_2997(10, 0, 0, 70))));
		biome.method_8719(class_2893.class_2895.field_13176, class_3031.field_13517.method_23397(new class_3124(class_3124.class_3125.field_13730, class_2246.field_10115.method_9564(), 33)).method_23388(class_3284.field_14241.method_23475(new class_2997(10, 0, 0, 70))));
	}

	public static void addConiferousForestTrees(class_1959 biome) {
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_13510.method_23397(FIR_TREE_CONFIG).method_23388(class_3284.field_14267.method_23475(new class_3276(7, 0.1F, 1))));
	}

	public static void addDesertShrublandFeatures(class_1959 biome) {
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_13537.method_23397(new class_4643.class_4644(
			new class_4656(class_2246.field_10431.method_9564()), new class_4656(class_2246.field_10503.method_9564())).method_23445())
			.method_23388(class_3284.field_14267.method_23475(new class_3276(2, 0.1F, 1))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_13537.method_23397(new class_4643.class_4644(
			new class_4656(class_2246.field_10431.method_9564()), new class_4656(class_2246.field_10503.method_9564())).method_23445())
			.method_23388(class_3284.field_14267.method_23475(new class_3276(2, 0.1F, 1))));
	}

	public static void addRollingHillsVegetation(class_1959 biome) {
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(LUSH_FLOWER_CONFIG).method_23388(class_3284.field_14253.method_23475(new class_3273(5))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(class_3864.field_21201).method_23388(class_3284.field_14240.method_23475(new class_3273(15))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_13510.method_23397(class_3864.field_21126).method_23388(class_3284.field_14267.method_23475(new class_3276(2, 0.2F, 1))));

	}

	public static void addLushSwampVegetation(class_1959 biome) {
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_13510.method_23397(TALL_SWAMP_TREE_CONFIG).method_23388(class_3284.field_14267.method_23475(new class_3276(2, 0.1F, 1))));

		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21219.method_23397(class_3864.field_21205).method_23388(class_3284.field_14253.method_23475(new class_3273(1))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(class_3864.field_21201).method_23388(class_3284.field_14240.method_23475(new class_3273(5))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(class_3864.field_21090).method_23388(class_3284.field_14240.method_23475(new class_3273(1))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(class_3864.field_21095).method_23388(class_3284.field_14240.method_23475(new class_3273(4))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(class_3864.field_21097).method_23388(class_3284.field_14234.method_23475(new class_3271(8, 0.25F))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(class_3864.field_21096).method_23388(class_3284.field_14261.method_23475(new class_3271(8, 0.125F))));
	}

	public static void addMeadowVegetation(class_1959 biome) {
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(class_3864.field_21201).method_23388(class_3284.field_14240.method_23475(new class_3273(15))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(LUSH_FLOWER_CONFIG).method_23388(class_3284.field_14253.method_23475(new class_3273(10))));
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_13510.method_23397(class_3864.field_21191).method_23388(class_3284.field_14267.method_23475(new class_3276(0, 0.2F, 1))));
	}

	public static void addMiniJungleVegetation(class_1959 biome) {
		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_13593.method_23397(new class_3141(
			ImmutableList.of( class_3031.field_13529.method_23397(
				class_3864.field_21190).method_23387(0.1F)),
			class_3031.field_13510.method_23397(class_3864.field_21167))).method_23388(class_3284.field_14267.method_23475(new class_3276(50, 0.1F, 1))));

		biome.method_8719(class_2893.class_2895.field_13178, class_3031.field_21220.method_23397(class_3864.field_21205).method_23388(class_3284.field_14240.method_23475(new class_3273(4))));
	}

	public static void addRockyEdgeFeatures(class_1959 biome) {
		biome.method_8719(class_2893.class_2895.field_13171, class_3031.field_13584.method_23397(new class_2951(class_2246.field_10445.method_9564(), 1)).method_23388(class_3284.field_14264.method_23475(new class_3273(3))));
	}

	public static void addWoodlandsTrees(class_1959 biome, int count) {
		biome.method_8719(
			class_2893.class_2895.field_13178,
			class_3031.field_13593.method_23397(new class_3141(
				ImmutableList.of(class_3031.field_13537.method_23397(new class_4643.class_4644(
					new class_4656(class_2246.field_10431.method_9564()), new class_4656(class_2246.field_10503.method_9564())).method_23445())
					.method_23387(0.2F),
					TraverseFeatures.FALLEN_OAK_TREE.method_23397(new FallenLogFeatureConfig.Builder(
						new class_4656(class_2246.field_10431.method_9564()), new class_4656(class_2246.field_10503.method_9564())).baseLength(3).lengthRandom(2).build())
						.method_23387(0.3F)),
				class_3031.field_13510.method_23397(class_3864.field_21126)))
				.method_23388(class_3284.field_14238.method_23475(new class_3273(count))));
	}
}
